#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "srl.h"

int checktmp(const char tmp[1])
{
 int x=1;

 if(tmp[0]==10) x=-1; else
 if(tmp[0]==-1) x=-1; else
 if(tmp[0]=='#') x=-1;

 return x;
}

s_line s_rdln (int fd)
{
 int x,y,z;
 char *buf,tmp[1];
 s_line ret;
 
 buf=(char *) malloc(S_LINEMAX);
 
 x=ret.cellcount=ret.eof=z=0;

 if (read(fd,tmp,1)!=1) tmp[0]=-1;

 while(tmp[0]==' ' || tmp[0]==9 && tmp[0]!=-1)
  if (read(fd,tmp,1)!=1) tmp[0]=-1;
  
 while (checktmp(tmp)==1)
 {
  buf[x]=tmp[0];

  x++;
  if (read(fd,tmp,1)!=1) tmp[0]=-1;
  
  if ( tmp[0]==' ' || tmp[0]==9 || buf[0]=='"')
   { /* NEW CELL */
    if(buf[0]=='"') {
     z=1;
     buf[x]=tmp[0];
     read(fd,tmp,1);
     while(tmp[0]!='"')
     {
      x++;
      buf[x]=tmp[0];
      if (read(fd,tmp,1)!=1) tmp[0]='"';
     }
     x++;
    }

    ret.cell[ret.cellcount]=(char *) malloc(x+1);
    memset(ret.cell[ret.cellcount],0,x+1);
     for(y=z; y<x; y++)
      ret.cell[ret.cellcount][y-z]=buf[y];
     ret.cell[ret.cellcount][y-z]=0;
    ret.cellcount++;

    x=z=0;
    memset(buf,0,S_LINEMAX);
   
    read(fd,tmp,1);
     while (tmp[0]==' ' || tmp[0]==9) read(fd,tmp,1);
   }

 }
 
 if (tmp[0]=='#')
  {
   read(fd,tmp,1);
   while(tmp[0]!=10 && tmp[0]!=-1)
     if (read(fd,tmp,1)!=1) tmp[0]=-1;
  }

 if (tmp[0]==-1) ret.eof=1;

 if (x!=0)
  {
   ret.cell[ret.cellcount]=(char *) malloc(x+1);
   memset(ret.cell[ret.cellcount],0,x+1);
   for(y=0; y<x; y++)
    ret.cell[ret.cellcount][y]=buf[y];
   ret.cell[ret.cellcount][y]=0;
   ret.cellcount++;
  }

 if (x==0 && ret.cellcount==0)
  ret.cellcount=S_EMPTYLINE;
   
 free(buf); 

 return ret;
}